Program Keep;
---------------------------
-- FeaTuReS: dirty code  --
-- floating point math   --
-- no optimisation       --
-- sorry...              --
-- in fact, here is only --
-- one funny thing:      --
-- procedure which       --
-- genetates dot objects --
-- use it if you like,   --
-- send me greetings     --
---------------------------
-- questions? feel free  --
-- mail to:              --
-- kolejnik@ck-sg.p.lodz.pl
---------------------------
const
             NrObjects = 10;                     -- number of objects
                    Lp = 1024;                   -- how many points in object
                 steps = 20;                     -- steps of morph
var
      crdX, crdY, crdZ : array[ 0..NrObjects-1, 0..Lp ] of integer;
                   clr : array[ 0..Lp ] of byte;
            cosT, sinT : array[ 0..255 ] of real;
  who, cnt, x0, y0, z0,
 v, q, j, k, i, wx, wy : integer;
        VirBuf, VirAdr : Dword;                      -- offsets for buffer
        Buffer, VirScr : array[ 0..64639 ] of byte;  -- mem for buffer
                paleta : array[ 1..768 ] of byte;
     alfa, beta, gamma : byte;                       -- angles
      zAxe, dx, dy, dz,
      wsp1, wsp2, wsp3 : real;
               licznik : word;
                    ok : boolean;

{$L fastmove.obj}

procedure FillDWord( dest, size, wyp : dword ); external;
procedure MoveD( src, dest, sizes : Dword ); external;
procedure SetMode( tryb : word ); external;
procedure FlipScreen( adres : dword ); external; --- with wait for retrace
procedure PutPixel( x, y : word; clr : byte; adres : dword ); external;

{$L fuzzy.obj}

procedure FuzzyScreen( ekran : dword; ilePix : word ); external;
procedure DrawSquare( x, y : word; clr : byte; adres : dword ); external;

procedure SetPal; assembler;
asm
  xor  AL, AL
  mov  DX, $3C8
  out  DX, AL
  mov  ESI, offset paleta
  mov  CX, 768
  mov  DX, $3C9
  rep  outsb
end;

procedure MakePalette; --- make beautiful and impressive palette  :-)
var i : byte;
begin
  FillChar( paleta, 768, 0 );
  for i:=0 to 31 do
    begin
      paleta[ 3*( i+63 )+1 ]:=i SHL 1;
      paleta[ 3*( i+63 )+2 ]:=i;
      paleta[ 3*( i+63 )+3 ]:=0;
      paleta[ 3*( i+94 )+1 ]:=63;
      paleta[ 3*( i+94 )+2 ]:=i+32;
      paleta[ 3*( i+94 )+3 ]:=0;
      paleta[ 3*( i+129 )+1 ]:=i SHL 1;
      paleta[ 3*( i+129 )+2 ]:=i;
      paleta[ 3*( i+129 )+3 ]:=0;
      paleta[ 3*( i+160 )+1 ]:=63;
      paleta[ 3*( i+160 )+2 ]:=i+32;
      paleta[ 3*( i+160 )+3 ]:=0;
    end;
  for i:=126 to 128 do
    begin
      paleta[ 3*i+1 ]:=i-65;
      paleta[ 3*i+2 ]:=i-65;
      paleta[ 3*i+3 ]:=( i-112 )*4-1;
    end;
  for i:=129 to 255 do
    begin
      paleta[ 3*i+1 ]:=i DIV 2;
      paleta[ 3*i+2 ]:=0;
      paleta[ 3*i+3 ]:=i DIV 3;
    end;
  SetPal;
end;

procedure Morph( zr, cel : byte ); --- dotyczy tablic crd<x>
var  daneZX, daneZY, daneZZ, daneCX, daneCY, daneCZ : integer;
begin
  daneZX:=crdX[ zr, cnt ];  daneCX:=crdX[ cel, cnt ];
  daneZY:=crdY[ zr, cnt ];  daneCY:=crdY[ cel, cnt ];
  daneZZ:=crdZ[ zr, cnt ];  daneCZ:=crdZ[ cel, cnt ];
  crdX[ cel, cnt ]:=daneCX+( daneZX-daneCX ) DIV q;
  crdY[ cel, cnt ]:=daneCY+( daneZY-daneCY ) DIV q;
  crdZ[ cel, cnt ]:=daneCZ+( daneZZ-daneCZ ) DIV q;
end;

procedure JustRotate( crd1, crd2, crd3 : real; kat : byte );
var pcs, psn : real;
 -- X axis: wsp1=Y, wsp2=Z
 -- Y axis: wsp1=Z, wsp2=X
 -- Z axis: wsp1=X, wsp2=Y
begin
  pcs:=cosT[ kat ];
  psn:=sinT[ kat ];
  dx:=crd1*pcs-crd2*psn;
  dy:=crd2*pcs+crd1*psn;
  dz:=crd3;
end;                                          -- all axis rotation

procedure MakeSinCos;                         -- make Look Up Table
begin
  for i:=0 to 255 do
    begin
      sinT[ i ]:=sin( 2*i*pi/256 );
      cosT[ i ]:=cos( 2*i*pi/256 );
    end
end;

procedure MakeFigure( x1, y1, z1, radius : integer );
var
    dv, abac, rnd, az, bz : byte;
   hnd5, hnd2, hnd1, hnd3 : integer;
 hnd4, csT, snT, bfx, bfy : real;
                   koszyk : array[ 0..Lp ] of byte;

begin
  az:=Lp DIV ( 2*radius );
  bz:=Lp DIV 128;                -- use only positive values of sin
  for i:=0 to Lp do koszyk[ i ]:=random( 256 );
  i:=0;
  repeat
    rnd:=koszyk[ i ];            -- put dots on surface in random order
    bfx:=radius*sinT[ rnd ];
    bfy:=radius*cosT[ rnd ];
    for abac:=0 to 9 do
      crdZ[ abac, i ]:=z1+( i DIV az ); -- Z is always the same
    clr[ i ]:=random( 20 )+109;         -- random colors
    dv:=i DIV bz;
    csT:=cosT[ dv ];
    snT:=sinT[ dv ];
    hnd1:=round( sqr( snT )*bfy );      -- speed up calculations
    hnd2:=round( sqr( csT )*bfx );
    hnd3:=round( sqr( csT )*bfy );
    hnd4:=sqrt( snT );
    hnd5:=round( bfx*snT*csT );
           --------------------------- ball
    crdX[ 0, i ]:=x1+round( hnd4*bfx );
    crdY[ 0, i ]:=y1+round( hnd4*bfy );
    crdX[ 9, i ]:=crdX[ 0, i ]; -- last object must be the same as first
    crdY[ 9, i ]:=crdY[ 0, i ];
           --------------------------- cylinder
    crdX[ 8, i ]:=x1+round( bfx );
    crdY[ 8, i ]:=y1+round( bfy );
           --------------------------- bak (SQR as replacement SQRT)
    crdX[ 2, i ]:=x1+round( sqr( snT )*bfx );
    crdY[ 2, i ]:=y1+hnd1;
           --------------------------- klepsydra (cosT as replacement sinT)
    crdX[ 3, i ]:=x1+hnd2;
    crdY[ 3, i ]:=y1+hnd3;
           --------------------------- sweet (?)
    crdX[ 4, i ]:=x1+hnd2;
    crdY[ 4, i ]:=y1+hnd1;
           --------------------------- bumped cylinder
    crdX[ 5, i ]:=x1+hnd2;
    crdY[ 5, i ]:=y1+round( bfy );
           --------------------------- bubble
    crdX[ 6, i ]:=x1+round( bfx );
    crdY[ 6, i ]:=y1+hnd1;
           --------------------------- ?
    crdX[ 7, i ]:=x1+hnd5;
    crdY[ 7, i ]:=y1+hnd1;
           --------------------------- kokarda
    crdX[ 1, i ]:=x1+hnd5;
    crdY[ 1, i ]:=y1+hnd3;
    inc( i );
  until i = Lp+1;
end;

BEGIN
  VirAdr:=Ofs( VirScr );
  VirBuf:=Ofs( Buffer );
  MakeSinCos;
  MakeFigure( -15, -10, -40, 38 );
  SetMode( $13 );
  MakePalette;
  FillDWord( VirBuf, 16160, 0 );
  FillDWord( VirAdr, 16160, 0 );
  alfa:=0;  beta:=0;  gamma:=0;  q:=steps; v:=0;  who:=0;  ok:=false;
  x0:=160;  y0:=100;  z0:=-150;                   -- observer
  repeat
    inc( v );
    if v = 150 then begin ok:=true; q:=steps; inc( who ); v:=0; end;
    if q = 0 then ok:=false;
    if who = NrObjects then who:=1;
    inc( alfa );  inc( beta, 2 );  inc( gamma, 4 );
    moveD( VirBuf+32000, VirAdr+32000, 8000 );  -- clear half of buffer
    cnt:=0;
    repeat
      if ok then Morph( who, 0 );
      dx:=crdX[ 0, cnt ];
      dy:=crdY[ 0, cnt ];
      dz:=crdZ[ 0, cnt ];
      JustRotate( dx, dy, dz, alfa );   -- Z axe
      JustRotate( dy, dz, dx, beta );   -- X axe
      JustRotate( dz, dx, dy, gamma );  -- Y axe
      zAxe:=dy-z0;
      wx:=round( x0+256*dz/zAxe );            -- X perspective
      if ( wx > 0 ) AND ( wx < 318 )          -- is the point on the screen ?
        then begin                            -- if yes, calc Y perspective
               wy:=round( y0+256*dx/zAxe );   -- Y perspective
               if ( wy > 0 ) AND ( wy < 99 )  -- first half of the screen
                 then DrawSquare( wx, wy, clr[ cnt ], VirAdr );
               if ( wy >= 99 ) AND ( wy < 200 )  -- the second one
                 then PutPixel( wx, wy, clr[ cnt ], VirAdr );
             end;
      inc( cnt );
    until cnt = Lp+1;
    FuzzyScreen( VirAdr, 32000 );
    FlipScreen( VirAdr );
    dec( q );
  until port[ $60 ] = 1;                   -- Esc pressed
  SetMode( $03 );
  writeLn('(c) by K!O 1998');
END.